%define pmacutilsver 2.1
%define ppc64utilsver 1.1.3
%define powerpcutilsver 1.2.10
%define libvpdver 2.1.2
%define lsvpdver 1.6.8

Summary: Linux/PPC64 specific utilities
Name:    ppc64-utils
Version: 0.13
Release: 13%{?dist}

# The things that do not have URLs in the source entry are Red Hat creations,
# except pmac-utils, which just isn't available upstream anymore.
# The licensing of these things are all different.
#     Red Hat creations      either GPLv2 or GPLv2+
#     pmac-utils             GPLv2
#     powerpc-utils          IBM
#     powerpc-utils-papr     IBM
#     libvpd                 LGPLv2+
#     lsvpd                  GPLv2+
License: GPLv2 and GPLv2+ and LGPLv2+ and IBM

Group:   System Environment/Base

Source0: http://prdownloads.sourceforge.net/powerpc-utils/powerpc-utils-%{powerpcutilsver}.tar.gz
Source1: addRamDisk.c
Source2: addSystemMap.c
Source3: mkzimage
Source4: addnote.c
Source5: pmac-utils-%{pmacutilsver}.tar.gz
Source6: zImage-boot.tar.gz
Source7: http://downloads.sourceforge.net/linux-diag/libvpd-%{libvpdver}.tar.gz
Source8: http://downloads.sourceforge.net/linux-diag/lsvpd-%{lsvpdver}.tar.gz

# missing man pages
Source10: addRamDisk.8.gz
Source11: addSystemMap.8.gz
Source12: lsprop.8.gz
Source13: ppc64_cpu.8.gz
Source14: rtas_event_decode.8.gz
Source15: drmgr.8.gz
Source16: ls-vdev.8.gz
Source17: ls-veth.8.gz
Source18: ls-vscsi.8.gz
Source19: lsdevinfo.8.gz
Source20: lsslot.8.gz
Source21: mkzimage.8.gz

Patch0: pmac-utils-0.4-cell.patch
Patch1: ppc64-utils-1.1-64k.patch
Patch2: lsvpd-1.6.8-Makefile.patch
Patch3: lsvpd-1.6.8-rmopt.patch
Patch4: lsvpd-1.6.8-devopt.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch: ppc
BuildRequires: linuxdoc-tools
BuildRequires: librtas-devel >= 1.3.3
BuildRequires: libtool
BuildRequires: zlib-devel
BuildRequires: libstdc++-devel
BuildRequires: db4-devel
BuildRequires: sg3_utils-devel
BuildRequires: sqlite-devel

Requires: binutils
Requires: yaboot
Provides: powerpc-utils = %{powerpcutilsver}
Provides: powerpc-utils-papr = %{powerpcutilsver}
Provides: lsvpdver = %{lsvpdver}

%description
A collection of utilities for Linux on PPC64 platforms.

%package devel
Summary: Development headers and libraries for libvpd
Requires: %{name} = %{version}-%{release} sqlite-devel pkgconfig
Group: Development/Libraries

%description devel
Libraries and header files for libvpd, the Vital Product Data interface
library.

%prep
%setup -c -T -a 0 -a 5 -a 6 -a 7 -a 8
%{__cp} %{SOURCE1} %{SOURCE2} %{SOURCE3} %{SOURCE4} .

pushd pmac-utils-%{pmacutilsver}
%patch0 -p 1 -b .cell
popd

%patch1 -p 1 -b .64k

pushd lsvpd-%{lsvpdver}
%patch2 -p 1 -b .mf
./bootstrap.sh
popd

%patch3 -p 1 -b .rmopt
%patch4 -p 1 -b .devopt

# copy all docs over to one subdirectory
%{__mkdir} -p __docs/libvpd
pushd libvpd
%{__cp} -a AUTHORS COPYING NEWS README TODO ../__docs/libvpd
popd

%{__mkdir} -p __docs/lsvpd
pushd lsvpd-%{lsvpdver}
%{__cp} -a AUTHORS COPYING NEWS README TODO ../__docs/lsvpd
popd

%{__mkdir} -p __docs/pmac-utils
pushd pmac-utils-%{pmacutilsver}
%{__cp} -a COPYING README ../__docs/pmac-utils
popd

%{__mkdir} -p __docs/powerpc-utils
pushd powerpc-utils-%{powerpcutilsver}
%{__cp} -a COPYRIGHT README ../__docs/powerpc-utils
  
popd

find __docs -type f | xargs %{__chmod} 0644
find __docs -type d | xargs %{__chmod} 0755

%build
export CFLAGS="%{optflags}"

%{__cc} -O -fno-builtin -DSTDC_HEADERS addRamDisk.c -o addRamDisk
%{__cc} -O -fno-builtin -DSTDC_HEADERS addSystemMap.c -o addSystemMap
%{__cc} -O -fno-builtin -DSTDC_HEADERS addnote.c -o addnote

pushd powerpc-utils-%{powerpcutilsver}
%configure
popd

%{__make} -C powerpc-utils-%{powerpcutilsver} %{?_smp_mflags}
%{__make} -C pmac-utils-%{pmacutilsver} clean nvsetenv nvsetenv.8
%{__make} -C zImage-boot zImage.stub %{?_smp_mflags}

pushd libvpd
./bootstrap.sh
%configure --disable-static
%{__make} %{?_smp_mflags}
popd

pushd lsvpd-%{lsvpdver}
export CXXFLAGS="%{optflags} -I$(pwd)/../libvpd/src"
export LDADD="-L$(pwd)/../libvpd/.libs"
%configure
%{__make} %{?_smp_mflags}
popd

%install
%{__rm} -rf %{buildroot}

pushd powerpc-utils-%{powerpcutilsver}
%{__make} LIB_DIR=%{_libdir} DESTDIR=%{buildroot} install

# move init script
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d

popd

%{__mkdir} -p %{buildroot}/sbin
%{__mkdir} -p %{buildroot}/usr/bin
%{__mkdir} -p %{buildroot}/%{_mandir}/man8
%{__mkdir} -p %{buildroot}/usr/share/ppc64-utils
%{__install} -m 0755 mkzimage %{buildroot}/%{_bindir}
%{__install} -m 0755 addRamDisk %{buildroot}/sbin
%{__install} -m 0755 addSystemMap %{buildroot}/sbin
%{__install} -m 0644 zImage-boot/zImage.lds %{buildroot}/usr/share/ppc64-utils
%{__install} -m 0644 zImage-boot/zImage.stub %{buildroot}/usr/share/ppc64-utils
%{__install} -m 0755 addnote %{buildroot}/usr/share/ppc64-utils

# Missing man pages
%{__install} -m 0644 \
    -t  %{buildroot}/%{_mandir}/man8 \
    %{SOURCE10} %{SOURCE11} %{SOURCE12} %{SOURCE13} %{SOURCE14} %{SOURCE15} \
    %{SOURCE16} %{SOURCE17} %{SOURCE18} %{SOURCE19} %{SOURCE20} %{SOURCE21}

pushd pmac-utils-%{pmacutilsver}
%{__install} -m 0755 nvsetenv %{buildroot}/sbin
%{__install} -m 0755 nvsetenv.8 %{buildroot}/%{_mandir}/man8
popd


pushd libvpd
%{__make} install DESTDIR=%{buildroot}
popd

pushd lsvpd-%{lsvpdver}
%{__make} install DESTDIR=%{buildroot}
popd

%{__rm} -rf %{buildroot}/%{_docdir}/packages
%{__rm} -rf %{buildroot}/%{_libdir}/*.la

%clean
%{__rm} -rf %{buildroot}

%post

%preun

%postun

%files
%defattr(-,root,root,-)
%doc __docs/*
%dir %{_sysconfdir}/lsvpd
%config(noreplace) %{_sysconfdir}/lsvpd/scsi_templates.conf
%config(noreplace) %{_sysconfdir}/lsvpd/cpu_mod_conv.conf
/sbin/addRamDisk
/sbin/addSystemMap
/sbin/nvsetenv
%{_datadir}/%{name}/
%{_bindir}/mkzimage
%{_bindir}/amsstat
%{_libdir}/libvpd*.so*
%{_sbindir}/activate_firmware
%{_sbindir}/bootlist
%{_sbindir}/drmgr
%{_sbindir}/hvcsadmin
%{_sbindir}/lscfg
%{_sbindir}/lsmcode
%{_sbindir}/lsvio
%{_sbindir}/lsvpd
%{_sbindir}/nvram
%{_sbindir}/lsprop
%{_sbindir}/lsdevinfo
%{_sbindir}/lsslot
%{_sbindir}/ls-veth
%{_sbindir}/ls-vdev
%{_sbindir}/ls-vscsi
%{_sbindir}/ofpathname
%{_sbindir}/ppc64_cpu
%{_sbindir}/rtas_dump
%{_sbindir}/rtas_event_decode
%{_sbindir}/rtas_ibm_get_vpd
%{_sbindir}/serv_config
%{_sbindir}/set_poweron_time
%{_sbindir}/snap
%{_sbindir}/sys_ident
%{_sbindir}/uesensor
%{_sbindir}/update_flash
%{_sbindir}/usysattn
%{_sbindir}/usysident
%{_sbindir}/vpdupdate
%{_sbindir}/lparstat

%{_mandir}/man1/amsstat.1*
%{_mandir}/man8/*.8*
%{_mandir}/man5/lparcfg.5*

%files devel
%defattr(-,root,root,-)
%{_includedir}/libvpd-2/
%{_libdir}/libvpd.so
%{_libdir}/libvpd_cxx.so
%{_libdir}/pkgconfig/libvpd-2.pc
%{_libdir}/pkgconfig/libvpd_cxx-2.pc

%changelog
* Fri Jan 13 2012 Jiri Skala <jskala@redhat.com> - 0.13-13
- Resolves: #739706 - lsmcode.8 improved man page

* Fri Jan 13 2012 Jiri Skala <jskala@redhat.com> - 0.13-12
- Resolves: #739706 - lsmcode.8 improved man page

* Wed Jan 11 2012 Jiri Skala <jskala@redhat.com> - 0.13-11
- Resolves: #739706 - lsmcode options give incomplete and incorrect information; updated patch

* Thu Sep 22 2011 Jiri Skala <jskala@redhat.com> - 0.13-10
- Resolves: #739706 - lsmcode options give incomplete and incorrect information

* Wed Aug 31 2011 Jiri Skala <jskala@redhat.com> - 0.13-9
- Resolves: #714179 - Update powerpc-utils; removed obsolete patches

* Mon Aug 29 2011 Jiri Skala <jskala@redhat.com> - 0.13-8
- Resolves: #666054 - inconsistency between man page and command-line help
- Resolves: #705012 - "Starting ibmvscsisd: [FAILED]"
- Resolves: #651877 - lparstat tool for Power
- Resolves: #714179 - Update powerpc-utils for enabling the SAS VRAID boot support

* Mon Nov 22 2010 Roman Rakus <rrakus@redhat.com> - 0.13-7
- support PCI DLPAR remove operations on the Jupiter and Juno Power platforms
  Resolves: rhbz#655087

* Fri Oct 29 2010 Roman Rakus <rrakus@redhat.com> - 0.13-6
- Added missing man page for mkzimage
  Resolves: rhbz#555781

* Tue Oct 05 2010 Roman Rakus <rrakus@redhat.com> - 0.13-5
- Another missing man pages
  Resolves: rhbz#555781

* Mon Oct 04 2010 Roman Rakus <rrakus@redhat.com> - 0.13-4
- Another man page typo fix
  Resolves: rhbz#578516

* Wed Sep 29 2010 Roman Rakus <rrakus@redhat.com> - 0.13-3
- Clear the post scripts, there is vpdupdater no more
  Resolves: rhbz#638513

* Tue Sep 21 2010 Roman Rakus <rrakus@redhat.com> - 0.13-2
- Added missing man pages
  Resolves: rhbz#555781

* Mon Sep 06 2010 Roman Rakus <rrakus@redhat.com> - 0.13-1
- Update powerpc-utils to 1.2.5
  Resolves: rhbz#579800
- Corrected LDADD

* Wed Sep 01 2010 Roman Rakus <rrakus@redhat.com> - 0.12-1
- Update lsvpd to 1.6.8
  Resolves: rhbz#565612

* Wed Sep 01 2010 Roman Rakus <rrakus@redhat.com> - 0.11-16
- Temporary turn off lsvpd
  Resolves: rhbz#565612

* Tue Aug 31 2010 Roman Rakus <rrakus@redhat.com> - 0.11-15
- Updated libvpd to 2.1.2
- Man page typo fix
- Man page update
- Properly convert lpfc device name to OFW device path name
  Resolves: rhbz#566271,#577338,#580992,#578516 

* Wed Feb 17 2010 Roman Rakus <rrakus@redhat.com> 0.11-14
- Don't print errors in lsdevinfo on Power6 machine with Virtual Fibre Channel
- Display data attempting to use the HMC to display the end to end virtual
  device topology
  Resolves: rhbz#565518

* Tue Dec 08 2009 Roman Rakus <rrakus@redhat.com> - 0.11-13
- rebase powerpc-utils to 1.2.2
  includes powerpc-utils-papr which is no longer needed
  Resolves: rhbz#514813, rhbz#512373

* Wed Jun 17 2009 Roman Rakus <rrakus@redhat.com> - 0.11-12
- rebase powerpc-utils to version 1.1.3
  Resolves: rhbz#477201

* Mon Mar 16 2009 Roman Rakus <rrakus@redhat.com> - 0.11-11
- Added support for virtual fibre-channel devices
  Resolves: rhbz#477201

* Mon Oct 20 2008 Roman Rakus <rrakus@redhat.com> - 0.11-10
- Added addnote.c util to this package
  Resolves: rhbz#467477

* Thu Feb 07 2008 David Cantrell <dcantrell@redhat.com> - 0.11-9
- Really compile everything with -D_FORTIFY_SOURCE=2
  Related: rhbz#253521

* Tue Jan 15 2008 David Cantrell <dcantrell@redhat.com> - 0.11-8
- Add missing -D_FORTIFY_SOURCE=2 to /usr/sbin/activate_firmware
  Related: rhbz#253521

* Mon Jan 07 2008 David Cantrell <dcantrell@redhat.com> - 0.11-7
- Add back -D_FORTIFY_SOURCE=2 to powerpc-utils and powerpc-utils-papr programs
  Related: rhbz#253519
  Related: rhbz#253521

* Mon Jan 07 2008 David Cantrell <dcantrell@redhat.com> - 0.11-6
- Rebuild
  Related: rhbz#253519
  Related: rhbz#253521
  Related: rhbz#253523

* Tue Dec 18 2007 David Cantrell <dcantrell@redhat.com> - 0.11-5
- BR librtas-devel >= 1.3.3
  Related: rhbz#253522

* Tue Dec 04 2007 David Cantrell <dcantrell@redhat.com> - 0.11-4
- Added lsvpd-1.4.0 and libvpd-1.4.1 for Vital Product Data commands
  Resolves: rhbz#253523

* Wed Nov 21 2007 David Cantrell <dcantrell@redhat.com> - 0.11-3
- Update to powerpc-utils-1.0.6
  Resolves: rhbz#253519
- Update to powerpc-utils-papr-1.0.4
  Resolves: rhbz#253521

* Mon Jan 08 2007 Paul Nasrat <pnasrat@redhat.com> - 0.11-2
- Fix for nvram (#217526)

* Mon Oct 30 2006 Paul Nasrat <pnasrat@redhat.com> - 0.11-1
- Update powerpc-utils to 1.0.3 (#212181)

* Mon Oct 16 2006 Paul Nasrat <pnasrat@redhat.com> - 0.10-1
- Include powerpc-utils and powerpc-utils-papr (#184685)

* Sun Oct 01 2006 Jesse Keating <jkeating@redhat.com> - 0.9-15
- rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Thu Sep 21 2006 Peter Jones <pjones@redhat.com> - 0.9-14
- Fix iSeries support in addRamDisk

* Fri Jul 14 2006 Jesse Keating <jkeating@redhat.com> - 0.9-13
- rebuild

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 0.9-12.2.1
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 0.9-12.2
- rebuilt for new gcc4.1 snapshot and glibc changes

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Fri Nov 18 2005 David Woodhouse <dwmw2@redhat.com> - 0.9-12
- Update zImage.stub from 2.6.15-rc1 kernel
- Link zImage at 3MiB since the POWER5 doesn't like it at 8MiB

* Tue Oct 25 2005 Paul Nasrat <pnasrat@redhat.com> - 0.9-11
- Bump internal version above rhel4 ver
- Pull in later ppc64-utils (#169035)

* Tue Oct 25 2005 Paul Nasrat <pnasrat@redhat.com> - 0.7-13
- Stop scanning nvram on broken content (#170418)

* Tue Sep 27 2005 David Woodhouse <dwmw2@redhat.com> - 0.7-12
- Work around old Pegasos II 'claim' method bug

* Wed Sep 21 2005 David Woodhouse <dwmw2@redhat.com> - 0.7-11
- Build zImage.stub 32-bit even on ppc64

* Tue Sep 20 2005 David Woodhouse <dwmw2@redhat.com> - 0.7-10
- Include zImage stub, capable of both ppc32 and ppc64 boot.

* Tue Mar 15 2005 Paul Nasrat <pnasrat@redhat.com> - 0.7-9
- Rebuild 

* Wed Oct 20 2004 Jeremy Katz <katzj@redhat.com> - 0.7-8
- add some more error handling to new mkzimage

* Wed Oct 20 2004 Jeremy Katz <katzj@redhat.com> - 0.7-7
- New mkzimage script from dhowells that works with the zImage.stub in 
  our 2.6 kernels
  - use mktemp instead of predictable filenames in /tmp
  - use the zImage.lds in the package instead of output by the script

* Wed Sep 22 2004 Jeremy Katz <katzj@redhat.com> - 0.7-5
- rebuild

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Mar  3 2004 Jeremy Katz <katzj@redhat.com> - 0.7-3
- rebuild

* Tue Nov  4 2003 Matt Wilson <msw@redhat.com> 0.7-2
- make clean before buildinig nvsetenv to nuke the old binary (#107943)

* Tue Sep 16 2003 Jeremy Katz <katzj@redhat.com> 0.7-1
- mkzimage bugfix

* Mon Aug 18 2003 Matt Wilson <msw@redhat.com> 0.6-1
- incorporate ppc64-utils 0.4 from IBM

* Mon Aug 11 2003 Matt Wilson <msw@redhat.com> 0.5-1
- add nvsetenv

* Wed Jul 30 2003 Matt Wilson <msw@redhat.com> 0.4-1
- add mkzimage for pSeries zImage creation with initrd

* Tue May 20 2003 Matt Wilson <msw@redhat.com> 0.3-1
- add addSystemMap from arch/ppc64/boot/addSystemMap.c

* Fri Apr 18 2003 Jeremy Katz <katzj@redhat.com> 0.2-1
- make addRamDisk quieter by default, set $VERBOSE to get old output

* Tue Apr 15 2003 Jeremy Katz <katzj@redhat.com> 0.1-1
- include addRamDisk from kernel source tree (arch/ppc64/boot/addRamDisk.c) 
  to create kernel/initrd blobs on iSeries


